import numpy as np
import matplotlib.pyplot as plt

def infimum(A, rangex):
    B = A * 1.0
    loss = []
    for x in rangex:
        B[1,1] = A[1,1] - x
        _, d, _ = np.linalg.svd(B)
        loss.append(d[1] ** 2)
    return loss

A1 = np.array([[1.0, 1.0],[1.0, 0.0]])
A2 = np.array([[1.0, 0.0],[0.0, 2.0]])
A3 = np.array([[0.0, 1.0],[1.0, 0.0]])

matrix = [A1, A2, A3]
loss = []
rangex = [np.linspace(-100, 100, 20000), np.linspace(-10, 14, 20000), np.linspace(-100,100, 20000)]

fontsize = 15
for (A, r) in zip(matrix, rangex):
    lossA = infimum(A, r)
    loss.append(lossA)

fig, ax = plt.subplots(1,3, figsize = (15,3.75))
for i in range(3):
    ax[i].plot(rangex[i], loss[i])
    ax[i].set_xlabel(r"$\sigma$")
    ax[i].set_ylabel(f"$g_{i+1}(\sigma)$")
plt.show()